
package de.ivu.elect.business.person.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.person.entity.Beruf;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractBerufEdit {

  @Inject
  protected BerufDAO dao;

  @Inject
  protected BerufExtendedDAO extendedDao;

  public void delete(Beruf entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Beruf entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Beruf entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Beruf getAttachedEntity(Beruf entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Beruf getAttachedAndRefreshedEntity(Beruf entity) {
    return dao.refresh(entity);
  }
}
